
-module(flags).
-compile(export_all).

start() ->
   % parent wants to know if children dies
   %process_flag(trap_exit, true),  
   register(one, spawn_link(?MODULE, func1, [])),
   register(two, spawn_link(?MODULE, func2, [])).

func1() -> 
   process_flag(trap_exit, true),
   aaa().

aaa() ->
   receive
      halt -> aaa_done;
      {'EXIT', Pid, Reason} ->
         io:fwrite("Server aaa gets EXIT ~p ~p ~n",[Pid,Reason]),
         aaa();
      0 -> 
         io:format("~p~n", [0]),
	 _ = 1/0,
         aaa();
      Msg -> 
         io:format("~p~n", [Msg]),
         aaa()
    end.

func2() -> 
   process_flag(trap_exit, true),
   bbb().

bbb() ->
   receive
      halt -> bbb_done;
      {'EXIT', Pid, Reason} ->
         io:fwrite("Server bbb gets EXIT ~p ~p ~n",[Pid,Reason]),
         bbb();
      0 -> 
         io:format("~p~n", [0]),
	 _ = 1/0,
         bbb();
      Msg -> 
         io:format("~p~n", [Msg]),
         bbb()
    end.

