
-module(trap).
-compile(export_all).

start() ->
   %process_flag(trap_exit, true),
   register(pa, spawn(?MODULE, loop, [])),
   register(pb, spawn(?MODULE, looq, [])).

loop() ->
   link(whereis(pb)),
   receive
      halt -> all_done;
      Msg -> 
         io:format("~p~n", [Msg]),
         loop()
   end.

looq() ->
   link(whereis(pa)),
   receive
      halt -> all_done;
      Num -> 
         io:format("~p~n", [Num]),
         _ = 1/Num,
         looq()
   end.

